package main

import "fmt"

type Node struct {
	Content string
	Next *Node
}


func Visit(first *Node, visitor func(*Node)) {
	var curs *Node 
	curs = first
	for curs != nil {
		visitor(curs)
		curs = curs.Next
	}
}

func PrintList(first *Node) {
	Visit(first, func (x *Node) {
		if x.Next != nil {
			fmt.Printf("%s -> ", x.Content)
		} else {
			fmt.Printf("%s\n", x.Content)
		}})
}

func Length(first *Node) int {
	conta := 0
	Visit(first, func (x *Node) {conta++})
	return conta
}

func AddFirst(first *Node, x string) *Node {
	nuovo := new(Node)
	nuovo.Content = x 
	nuovo.Next = first 
	return nuovo
}

func AddLast(first *Node, x string) *Node {
	var curs, prev *Node
	nuovo := new(Node)
	nuovo.Content = x 
	nuovo.Next = nil 
	// Scandisco la lista alla ricerca dell'ultimo nodo
	prev = nil
	curs = first
	for curs != nil {
		prev = curs
		curs = curs.Next
	}	
	if prev != nil {
		prev.Next = nuovo
		return first
	} else {
		return nuovo 
	}
}

 func AddInOrder(first *Node, x string) *Node {
	var curs, prev *Node
	nuovo := new(Node)
	nuovo.Content = x 
	// Scandisco la lista alla ricerca del primo nodo >=x
	prev = nil
	curs = first
	for curs != nil && curs.Content < x {
		prev = curs
		curs = curs.Next
	}	
	if prev == nil {   // Sto attaccando in testa (o su una lista vuota)
		nuovo.Next = first 
		return nuovo 
	} else {
		prev.Next = nuovo
		nuovo.Next = curs 
		return first 
	}

 }


func StampaNodo(x *Node) {
	fmt.Println(x.Content)
}

func main() {
	var first *Node
	first = AddInOrder(first, "Pappa")
	first = AddInOrder(first, "Pomodoro")
	first = AddInOrder(first, "La")
	first = AddInOrder(first, "Cagna")
	first = AddInOrder(first, "Topino")
	first = AddInOrder(first, "Carta")
	first = AddInOrder(first, "Zuppa")
	first = AddInOrder(first, "Aceto")
	first = AddInOrder(first, "Machete")

	PrintList(first)


}

